Kerbal Space Program - Feature #386

Engine gimbal steering does not account for COT being over COM
03/14/2013 01:06 AM - purpletarget

Status: Closed % Done: 100%
Severity: High

Assignee:

Category: Parts

Target version:

Platform: Any Mod Related: No
Expansion:

Description

What Happens:
When COM is lower than Centre of Thrust, the Yaw & Pitch Axis controls become effectively reversed. Rocket becomes
uncontrollable without reversing all controls, and PID controllers like ASAS cannot function correctly.

What's really happening:

Engine gimbals seem to have no awareness of their location wrt COM. They continue to react to commands as if they were at the
bottom of the rocket (below COM). But using the same steer direction at the bottom of the rocket, becomes a push on the nose of the
rocket in the opposite direction than intended when placed higher than COM. (Gimbals may be working as programmed, but not as
player-engineer/pilot may expect or intend)

How to reproduce:

Build any rocket with COT (Centre of Thrust) higher than COM. Attaching craft file as an example.

Launch from launchpad and low thrust to mostly hover.

Attempt to use yaw command to left, and note craft will yaw right instead. (Action of gimballing engines is also visibly in the wrong
direction to "push" top of rocket in the intended direction)

Attempt to use yaw command right, and the craft will yaw left instead. Similar reversal will exist on pitch axis as well.

Suggested Remedies:

While specific tuning of various controls in the VAB may be a future feature, fixing the bug right now could probably be accomplished
simply by making gimballed engines aware of the COM, and steer accordingly (reversing pitch/yaw vector if above COM). Expect
upcoming wheel steering logic could be leveraged.

Notes:
Already have seen plenty of vehicles designed as skyhooks. Pending addition of Rovers will likely increase frequency of vehicles
which have high mounted thrusters and a low COM for dropping payloads.

No effect on Yaw, since Gimbals have no roll authority yet. However, even if added, expect roll should not be affected by COM/COT
relationship.

Related issues:
Has duplicate Kerbal Space Program - Bug #3887: Gimbaled engines mounted forw... Duplicate 12/22/2014

History

#1 - 03/14/2013 03:30 PM - zxcvb55

- Tracker changed from Bug to Feature

This is an issue that should probably be addressed, but like you said, there's room in the future for fine tuning the controls. I'll go ahead and put it in
as a feature request, since it isn't as much a bug as it is a side-effect of the current implementation.

#2 - 03/18/2013 11:57 AM - purpletarget

The fine tuning features later may still need this fix regardless. COM is dynamic, adjusting for that change automatically in flight may be needed
anyways to keep craft from becoming uncontrollable as upper tanks drain.

Noticed in 0.19 there's a stock skycrane+rover vehicle which would suffer from this issue (doesn't only because probe torque overpowers the thrust
vectoring)

Given the prevalence that skycrane types a likely to have, and that this feeds into control-ability / game-play, suspect this will become more important.
Your call.

#3 - 04/02/2013 02:28 PM - DamionRayne
- Severity changed from Normal to High
- Platform Windows added

| can confirm this happening on the most recent version of the game, during normal gameplay. Also this CoM/CoT switch causes the camera to switch
back and forth a lot and is disorientating.

#4 - 04/18/2013 08:02 PM - Fel

purpletarget wrote:

The fine tuning features later may still need this fix regardless. COM is dynamic, adjusting for that change automatically in flight may be needed
anyways to keep craft from becoming uncontrollable as upper tanks drain.

Noticed in 0.19 there's a stock skycrane+rover vehicle which would suffer from this issue (doesn't only because probe torque overpowers the
thrust vectoring)

Given the prevalence that skycrane types a likely to have, and that this feeds into control-ability / game-play, suspect this will become more
important. Your call.

High mounted rockets really shouldn't be unusual to KSP (why build up when you can build down, it is the Kerbal way!)

Though, shouldn't the engine (in practice) adjust the gimbal angles based on the distance from the center of mass; and that would automatically fix
this error?

#5 - 08/12/2013 08:44 AM - weekendgamer

I can confirm this happens in 0.20 with an unmodified installation of KSP under normal use.

#6 - 08/20/2013 07:08 PM - triffid_hunter

This affects skycranes. A workaround is to disable engine gimballing and add SAS rings

#7 - 07/04/2014 06:01 PM - Ruedii

This should probably be set to be platform all as it is not platform specific.

#8 - 11/30/2014 01:41 PM - RexKramer
- Version changed from 0.18.4 to 0.25

- Platform Any added

- Platform deleted (Windows)

Changed platform to Any and version to 0.25.

#9 - 04/28/2015 02:59 AM - RexKramer
- Status changed from New to Resolved

- % Done changed from 0 to 100

Engine gimbaling now appears to work in the correct direction regardless of location relative to COM, 1.0, OSX, used the LV-T45 to test.

#10 - 07/17/2016 09:17 AM - TriggerAu

- Status changed from Resolved to Closed

Files

PT COG Thrust Vector Test.craft 13.4 KB 03/14/2013 purpletarget
